<!-- 委托方意见登记表 -->
<script lang="ts" setup name="ClientOpinionForm">
import { reactive, ref } from 'vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import { delOpinion, getListPage } from '@/api/eqpt/MeasurementBusiness/opinion'
const { proxy } = getCurrentInstance() as any
const listQuery = reactive({
  approvalStatus: '0',
  createTimeEnd: '',
  createTimeStart: '',
  createUserName: '',
  customerDeptName: '',
  customerName: '',
  formId: '',
  formNo: '',
  offset: 1,
  limit: 20,
})
// 证书有效期开始结束时间
const datetimerange = ref()
watch(() => datetimerange.value, (newVal) => {
  listQuery.createTimeStart = ''
  listQuery.createTimeEnd = ''
  if (Array.isArray(newVal)) {
    if (newVal.length) {
      listQuery.createTimeStart = `${newVal[0]} 00:00:00`
      listQuery.createTimeEnd = `${newVal[1]} 23:59:59`
    }
  }
})
const columns = ref([
  {
    text: '表单编号',
    value: 'formNo',
    align: 'center',
  },
  {
    text: '单位',
    value: 'customerName',
    align: 'center',
  },
  {
    text: '部门',
    value: 'customerDeptName',
    align: 'center',
  },
  {
    text: '创建人',
    value: 'createUserName',
    align: 'center',
  },
  {
    text: '创建时间',
    value: 'createTime',
    align: 'center',
  },
])
const list = ref([])
const total = ref(0)
const listLoading = ref(true)

// 获取数据
const fetchData = (isNowPage = true) => {
  listLoading.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.offset = 1
  }
  getListPage(listQuery).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    listLoading.value = false
  })
}
fetchData()
// 查询数据
const search = () => {
  fetchData(false)
}
// 重置
const reset = () => {
  datetimerange.value = []
  listQuery.formNo = ''
  listQuery.createUserName = ''
  listQuery.createTimeEnd = ''
  listQuery.createTimeStart = ''
  listQuery.offset = 1
  listQuery.limit = 20
  search()
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size: number; page: number }) => {
  if (val && val.size) {
    listQuery.limit = val.size
  }
  if (val && val.page) {
    listQuery.offset = val.page
  }
  fetchData()
}
const $router = useRouter()
// 新建编辑操作
const handler = (row: any, type: string) => {
  $router.push({
    path: `/opinion/${type}`,
    query: {
      row: JSON.stringify(row),
      id: row.id,
    },
  })
}
const delFun = (row: any) => {
  ElMessageBox.confirm(
    '确认删除吗？',
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then((res) => {
    delOpinion({ id: row.id, taskId: row.taskId }).then((res) => {
      ElMessage.success('操作成功')
      search()
    })
  })
}
</script>

<template>
  <app-container>
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <search-item>
        <el-input v-model.trim="listQuery.formNo" placeholder="表单编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.createUserName" placeholder="创建人" clearable />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="datetimerange" type="daterange" value-format="YYYY-MM-DD"
          format="YYYY-MM-DD" range-separator="至" start-placeholder="创建开始时间" end-placeholder="创建结束时间"
        />
      </search-item>
    </search-area>
    <table-container>
      <template #btns-right>
        <icon-button icon="icon-add" title="新增" @click="handler({}, 'create')" />
      </template>
      <!-- 普通表格 -->
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="listLoading"
        :is-showmulti-select="true" @change="changePage"
      >
        <template #columns>
          <el-table-column label="操作" width="160" align="center">
            <template #default="scope">
              <el-button link type="primary" size="small" @click="handler(scope.row, 'detail')">
                查看
              </el-button>
              <el-button link type="danger" size="small" @click="delFun(scope.row)">
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
</template>

